﻿using System;
using System.Linq;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Xml.Linq;
using System.Xml;
using System.Collections;
/*                                  Decision tree test                           */
/*                                                                               */
/*                       www.mosismath.com                                       */

namespace WindowsFormsApplication1
{
   
    public partial class Mainwin : Form
    {

        int samples = 0;
        int dataLength = 0;
        const int features = 4;

        public class TBranch
        {
            public double min;
            public double max;
            public double purity;
            public int iclass;
            public int iProperty;
            public TBranch[] nextBranch;
            public Collection<double[]> localValues;
            public TBranch()
            {
                nextBranch = new TBranch[2];
                purity = 100;
            }

            public int CheckBranch(double[] data)
            {
                int result = -1;

                if (purity == 0)
                {
                    if ((data[iProperty] <= max) && (data[iProperty] >= min))
                        result = iclass;
                    else
                    {
                        if (nextBranch[0] != null)
                            result = nextBranch[0].CheckBranch(data);
                    }
                }
                else
                {
                    if ((data[iProperty] <= max) && (data[iProperty] >= min) && (nextBranch[0] != null))
                        result = nextBranch[0].CheckBranch(data);
                    else
                    {
                        if ((nextBranch[1] != null) && result < 0)
                            result = nextBranch[1].CheckBranch(data);
                    }
                }
                return result;
            }

            public XElement writeBranch(int index)
            {
                XElement xmlBranch = new XElement("Branch", index);
                xmlBranch.Add(new XAttribute("Class", iclass));
                xmlBranch.Add(new XAttribute("Gini", purity));
                xmlBranch.Add(new XAttribute("Min", min));
                xmlBranch.Add(new XAttribute("Max", max));
                xmlBranch.Add(new XAttribute("Property", iProperty));
                if (nextBranch[0] != null)
                {
                    xmlBranch.Add(nextBranch[0].writeBranch(0));
                }
                if (nextBranch[1] != null)
                {
                    xmlBranch.Add(nextBranch[1].writeBranch(1));
                }
                return xmlBranch;
            }

            public XElement loadBranch(XElement xmlBranch)
            {
                iclass = Convert.ToInt32(xmlBranch.Attribute("Class").Value);
                purity = Convert.ToDouble(xmlBranch.Attribute("Gini").Value);
                min = Convert.ToDouble(xmlBranch.Attribute("Min").Value);
                max = Convert.ToDouble(xmlBranch.Attribute("Max").Value);
                iProperty = Convert.ToInt32(xmlBranch.Attribute("Property").Value);
                IEnumerable subChields = xmlBranch.Elements("Branch");
                if (subChields != null)
                {
                    foreach (XElement subelement in subChields)
                    {
                        int index = Convert.ToInt32(subelement.FirstNode.ToString());
                        if ((index >= 0) && (index < nextBranch.Length))
                        {
                            nextBranch[index] = new TBranch();
                            nextBranch[index].loadBranch(subelement);
                        }
                    }
                }
                return xmlBranch;
            }
        }
 
        public Mainwin()
        {
            InitializeComponent();
            gTest.ColumnCount = features + 2;
            gTest.RowCount = 15;
        }

        private void writeSetup(string FileName, TBranch branch)
        {
            XDocument doc = new XDocument();
            doc.Add(new XElement("Treesetting", null));
            using (XmlWriter writer = XmlWriter.Create(FileName))
            {
                doc.Root.Add(branch.writeBranch(0));
                doc.WriteTo(writer);
            }
        }

        private void readSetup(string FileName, TBranch branch)
        {
            XElement doc = XElement.Load(FileName);
            IEnumerable chields = doc.Elements("Branch");
            
            foreach (XElement el in chields)
            {
                branch.loadBranch(el);
            }
        }

       
        private void bt_Calc_Click(object sender, EventArgs e)
        {
            int i, j, flower;
            DataGridViewCell cell;
            TData testdata = new TData();
            TBranch testTrunc = new TBranch();

            gTest.Columns[0].HeaderText = "x1";
            gTest.Columns[1].HeaderText = "x2";
            gTest.Columns[2].HeaderText = "x3";
            gTest.Columns[3].HeaderText = "x4";
            gTest.Columns[4].HeaderText = "type";
            gTest.Columns[5].HeaderText = "output";

            testdata.readData(Application.StartupPath + "\\iris_Data.csv");
            samples = testdata.values.Count;
            dataLength = testdata.dataLength;
            for (i = 0; i < testdata.values.Count; i++)
            {
                gTest.Rows[i].HeaderCell.Value = (i + 1).ToString();
                for (j = 0; j <= features; j++)
                {
                    cell = gTest[j, i];
                    cell.Value = Math.Round(testdata.values.ElementAt(i)[j], 4).ToString();
                }
            }

            readSetup(Application.StartupPath + "\\setup.xml", testTrunc);
            for (i = 0; i < testdata.values.Count; i++)
            {
                flower = testTrunc.CheckBranch(testdata.values.ElementAt(i));
                cell = gTest[5, i];
                cell.Value = flower.ToString();
            }
        }
    }
}
